using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace UUN
{
    /// <summary>
    /// 动态文件的回贴列表编译部分
    /// </summary>
    public class 编译扩展_动态文件_回贴列表 : 编译扩展接口
    {
        private SqlConnection 连接;
        private HttpContext HC;
        private 编译器 编译器;

        public 编译扩展_动态文件_回贴列表(SqlConnection 连接, HttpContext HC, 编译器 编译器)
        {
            this.连接 = 连接;
            this.HC = HC;
            this.编译器 = 编译器;
        }

        private int 动态文件_回贴列表_一页显示记录数 = 0;

        public string 开始执行代码()
        {
            编译器.方法库 += @"	private String 当前页面=@"""+编译器.文件名称.Replace("\"","\"\"")+ @""";
	//参数
	private String 所属版块;
	private String 所属用户;
	private String 所属贴子;
	private int 排序;
	//其它
	private String 跳页表单项;
	private String _3G跳页表单项;
	private String 查询条件="""";
	//列表分页
	private int 当前页;
	private int 总页数;
	private int 总记录数;
	private int 一页显示记录数;
	private String 列表跳页(int 页码)
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?board=""+Server.UrlEncode(所属版块)+
		""&user=""+Server.UrlEncode(所属用户)+
		""&Topic=""+Server.UrlEncode(所属贴子)+
		""&order=""+排序+""&page=""+页码,访问.用户[""标识""].ToString()));
	}
	private String 生成余下全部地址()
	{
		return """";
	}
";
            String 返回值 = "";
            返回值 += @"	所属版块=Request.QueryString[""board""];
	所属用户=Request.QueryString[""user""];
	所属贴子=Request.QueryString[""Topic""];
	排序=Convert.ToInt32(Request.QueryString[""order""]);
	一页显示记录数=获取一页显示记录数();
	跳页表单项=""<postfield name=\""board\"" value=\""""+
		Server.UrlEncode(所属版块)+
		""\"" />""+
		""<postfield name=\""user\"" value=\""""+
		Server.UrlEncode(所属用户)+
		""\"" />""+
		""<postfield name=\""Topic\"" value=\""""+
		Server.UrlEncode(所属贴子)+
		""\"" />""+
		""<postfield name=\""order\"" value=\""""+
		排序+
		""\"" />""+
		""<postfield name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+访问.用户[""标识""]+""\"" />"";
	_3G跳页表单项=""<input type=\""hidden\"" name=\""board\"" value=\""""+
		Server.UrlEncode(所属版块)+
		""\"" />""+
		""<input type=\""hidden\"" name=\""user\"" value=\""""+
		Server.UrlEncode(所属用户)+
		""\"" />""+
		""<input type=\""hidden\"" name=\""Topic\"" value=\""""+
		Server.UrlEncode(所属贴子)+
		""\"" />""+
		""<input type=\""hidden\"" name=\""order\"" value=\""""+
		排序+
		""\"" />""+
		""<input type=\""hidden\"" name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+访问.用户[""标识""]+""\"" />"";
";
            返回值 += 生成回贴列表条件(true, "");
            返回值 += "\t\t当前页=Convert.ToInt32(Request.QueryString[\"page\"]);\r\n";
            返回值 += "\t\t总记录数=Convert.ToInt32(数量语句.ExecuteScalar());\r\n";
            返回值 += "\t\t总页数=常用.计算总页数(总记录数,一页显示记录数);\r\n";
            返回值 += "\t\t当前页=常用.计算当前页(总页数,当前页);\r\n";

            return 返回值;
        }

        private String 生成回贴列表条件(bool 是否数量, String 查询字段)
        {
            String 返回值 = "";
            String 语句名称 = 是否数量 ? "数量语句" : "语句";
            if (是否数量)
            {
                返回值 += @"		查询条件+="" WHERE 1=1"";
		if(所属版块!=""""&&所属版块!=""0""&&所属版块!=null)
		{
			String[] 版块数组=所属版块.Split(new char[]{'|'}, StringSplitOptions.RemoveEmptyEntries);
			String 所属版块查询=""("";
			for (int i = 0; i < 版块数组.Length; i++)
				所属版块查询 += (i == 0 ? """" : "" OR "") + ""[所属版块]="" + Convert.ToInt32(版块数组[i]);
			所属版块查询 += "")"";
			查询条件+="" AND ""+所属版块查询;
		}
		if(所属用户!=""""&&所属用户!=""0""&&所属用户!=null)
		{
			String[] 用户数组 = 所属用户.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);
			String 所属用户查询 = ""("";
			for (int i = 0; i < 用户数组.Length; i++)
				所属用户查询 += (i == 0 ? """" : "" OR "") + ""[回贴用户ID]="" + Convert.ToInt32(用户数组[i]);
			所属用户查询 += "")"";
			查询条件+="" AND ""+所属用户查询;
		}
		if(所属贴子!=""""&&所属贴子!=""0""&&所属贴子!=null)
		{
			String[] 贴子数组 = 所属贴子.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);
			String 所属贴子查询 = ""("";
			for (int i = 0; i < 贴子数组.Length; i++)
				所属贴子查询 += (i == 0 ? """" : "" OR "") + ""[贴子ID]="" + Convert.ToInt32(贴子数组[i]);
			所属贴子查询 += "")"";
			查询条件 += "" AND "" + 所属贴子查询;
		}
";
            }
            返回值 += "\t\tString " + 语句名称 + "SQL=\"SELECT " + (是否数量 ? "COUNT(ID)" : 查询字段) + " FROM [\"+程序.数据表前缀+\"社区_论坛_回贴]\"+查询条件;\r\n";

            if (!是否数量)
                返回值 += @"		" + 语句名称 + @"SQL+="" ORDER BY "";
		switch(排序)
		{
			case 0:
				"+语句名称+ @"SQL+=""[ID]"";
				break;
			case 1:
				"+语句名称+ @"SQL+=""[ID] DESC"";
				break;
			case 2:
				"+语句名称+ @"SQL+=""[支持] DESC,[反对] DESC"";
				break;
			default:
				"+语句名称+@"SQL+=""[反对] DESC,[支持] DESC"";
				break;
		}
";
            返回值 += "\t\tSqlCommand " + 语句名称 + "=new SqlCommand(" + 语句名称 + "SQL,访问.连接);\r\n";
            return 返回值;
        }

        public string 编译公共标签(string 代码)
        {
            switch (代码)
            {
                case "当前页":
                    return "\t\t返回值.Append(当前页);\r\n";
                case "总页数":
                    return "\t\t返回值.Append(总页数);\r\n";
                case "总记录数":
                    return "\t\t返回值.Append(总记录数);\r\n";
                default:
                    return "";

            }
        }

        public string 编译模板方法(string 方法名称, String[] 属性数组)
        {
            switch (方法名称)
            {
                case "_回贴列表":
                    return 编译模板方法_动态文件_回贴列表(属性数组[0],
                        属性数组[1],
                        属性数组[2],
                        Convert.ToInt32(属性数组[3]),
                        属性数组[4]);
                case "列表分页":
                    return 编译模板方法_动态文件_列表分页(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "分页设置":
                    return 编译模板方法_动态文件_分页设置(Convert.ToInt32(属性数组[0]));
                default:
                    return "";
            }
        }

        private String 编译模板方法_动态文件_回贴列表(String 空记录代码, String 格式, String 交替格式, int 字数, String 时间格式)
        {
            String 随机值 = 常用.随机字符(8);

            Hashtable 必须字段 = new Hashtable();
            必须字段.Add("序号", "");
            必须字段.Add("回贴列表地址", "所属版块,ID");
            必须字段.Add("版块地址", "所属版块");
            必须字段.Add("版块名称", "所属版块");
            必须字段.Add("回贴用户地址", "回贴用户ID");
            必须字段.Add("贴子地址", "所属版块,贴子ID");
            必须字段.Add("支持地址", "ID");
            必须字段.Add("反对地址", "ID");
            Hashtable 字段代码 = new Hashtable();
            字段代码.Add("序号", "(当前页-1)*一页显示记录数+i+1");
            字段代码.Add("回贴列表地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Reply.aspx?BID=""+行[""所属版块""]+""&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("版块地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Board.aspx?ID=""+行[""所属版块""],访问.用户[""标识""].ToString()))");
            字段代码.Add("版块名称", @"常用.获取版块名称(Convert.ToInt32(行[""所属版块""]))");
            字段代码.Add("回贴用户地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"User.aspx?ID=""+行[""回贴用户ID""]+""&rurl=""+Server.UrlEncode(Request.Url.ToString()),访问.用户[""标识""].ToString()))");
            字段代码.Add("回贴用户昵称", @"Server.HtmlEncode(行[""回贴用户昵称""].ToString())");
            字段代码.Add("回贴用户IP", @"行[""回贴用户IP""].ToString()==""""?"""":行[""回贴用户IP""].ToString().Substring(0,行[""回贴用户IP""].ToString().Length-4)+""****""");
            字段代码.Add("回贴用户地区", @"Server.HtmlEncode(行[""回贴用户地区""].ToString())");
            字段代码.Add("贴子地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Topic.aspx?BID=""+行[""所属版块""]+""&ID=""+行[""贴子ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("贴子标题", @"Server.HtmlEncode(行[""贴子标题""].ToString())");
            字段代码.Add("贴子内容", @"Server.HtmlEncode(常用.截取字符串(行[""回贴内容""].ToString()," + 字数 + "))");
            字段代码.Add("支持地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Reply_Case.aspx?z=true&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("反对地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Reply_Case.aspx?z=false&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("发表时间", @"Convert.ToDateTime(行[""发表时间""]).ToString(""" + 时间格式 + "\")");

            String 查询字段, 行代码;
            查询字段 = 编译器.生成查询字段(格式, 交替格式, 必须字段, 字段代码, out 行代码);

            编译器.方法库 += "\tprivate void 回贴列表" + 随机值 + "()\r\n";
            编译器.方法库 += "\t{\r\n";
            编译器.方法库 += "\t\tif(总记录数<1)\r\n";
            编译器.方法库 += "\t\t\t返回值.Append(@\"" + 空记录代码.Replace("\"", "\"\"") + "\");\r\n";
            编译器.方法库 += 生成回贴列表条件(false, 查询字段);
            编译器.方法库 += 生成查询结果列表(行代码);

            return "\t\t回贴列表" + 随机值 + "();\r\n";
        }
        private String 生成查询结果列表(String 行代码)
        {
            String 返回值 = "";
            返回值 += "\t\tDataSet 数据=new DataSet();\r\n";
            返回值 += "\t\tSqlDataAdapter 填充=new SqlDataAdapter(语句);\r\n";
            返回值 += "\t\t填充.Fill(数据,(当前页-1)*一页显示记录数,一页显示记录数,\"表\");\r\n";
            返回值 += "\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += 行代码;
            返回值 += "\t\t}\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_动态文件_列表分页(int ID, String 无分页代码)
        {
            return 编译器.编译内容分页(
                (编译器.文件名称.StartsWith(程序.安装位置 + "club/", StringComparison.OrdinalIgnoreCase) ? "Club" : "Content"),
                "Page", ID, 无分页代码);
        }

        private String 编译模板方法_动态文件_分页设置(int 一页显示记录数)
        {
            if (一页显示记录数 > 0)
                动态文件_回贴列表_一页显示记录数 = 一页显示记录数;
            return "";
        }

        public string 结束执行代码()
        {
            编译器.方法库 += @"	private int 获取一页显示记录数()
	{
";
            if (动态文件_回贴列表_一页显示记录数 == 0)
                编译器.方法库 += "\t\treturn 访问.获取一页显示记录数();\r\n";
            else
                编译器.方法库 += "\t\treturn " + 动态文件_回贴列表_一页显示记录数 + ";\r\n";
            编译器.方法库 += @"
	}
";
            return "";
        }

    }
}